<template>
  <q-layout view="hhh lpR lFf">

    <q-header
      reveal
      elevated
      class="text-white bg-primary"
    >
      <q-toolbar>
        <q-btn
          dense
          flat
          round
          icon="menu"
          @click="left = !left"
        />

        <q-toolbar-title>
        {{ title }}
        </q-toolbar-title>
        <q-space />
        <div v-if="student === 'admin'">
          <q-btn
            flat
            dense
            icon="notifications"
            auto-close
            size="md"
          >
            <q-badge
              color="red"
              floating
              transparent
              v-if="nNotify"
            >{{nNotify}}</q-badge>
            <q-menu
              transition-show="jump-down"
              transition-hide="jump-up"
              fit
              :offset="[0, 10]"
              anchor="bottom right"
              self="top right"
              v-close-popup
              auto-close
            >
              <q-item>
                <q-item-section>
                  <q-item-label>Notificaciones</q-item-label>
                </q-item-section>

                <q-item-section
                  side
                  bottom
                >
                  <q-item-label caption>
                    <a
                      class="text-primary"
                      primary
                    >Solicitudes</a>
                  </q-item-label>
                </q-item-section>
              </q-item>
              <q-separator />
              <q-list dense>
                <q-scroll-area style="height: 200px; max-width: 300px;">
                  <q-item
                    v-for="n in list"
                    :key="n.name"
                    clickable
                  >
                    <q-item-section
                      @click="ListNotify(n.dni)"
                    >
                      <q-item-label ovequasrline>{{n.name}}</q-item-label>
                      <q-item-label caption>{{n.carrera}}</q-item-label>
                    </q-item-section>
                    <q-item-section side>
                      <q-icon name="info" color="green"/>
                    </q-item-section>
                  </q-item>
                </q-scroll-area>
              </q-list>
            </q-menu>
          </q-btn>
        </div>
        <q-btn
          flat
          round
          dense
          icon="exit_to_app"
          class="q-mr-xs"
          @click="exit"
        />

      </q-toolbar>
    </q-header>

    <q-drawer
      show-if-above
      v-model="left"
      side="left"
      elevated
    >
      <q-list
        bordered
        separator
      >
        <q-item
          clickable
          :active="active_link_menu === '/menu'"
          @click="active_link_menu = '/menu'"
          active-class="my-menu-link"
          v-ripple
          icon="home"
          label="Inicio"
          to="/IndexStudent"
          v-if="title === 'Estudiante'"
        >
          <q-item-section avatar>
            <q-icon name="home" />
          </q-item-section>

          <q-item-section> inicio </q-item-section>
        </q-item>
        <q-item
          clickable
          :active="active_link_menu === '/menu'"
          @click="active_link_menu = '/menu'"
          active-class="my-menu-link"
          v-ripple
          icon="home"
          label="Inicio"
          to="/menu"
          v-if="title !== 'Estudiante'"
        >
          <q-item-section avatar>
            <q-icon name="home" />
          </q-item-section>

          <q-item-section> inicio </q-item-section>
        </q-item>
      </q-list>
      <div
        v-for="(item, index) in menu"
        v-bind:key="index"
      >
        <q-expansion-item
          expand-separator
          v-if="can(item.permission)"
          :icon="item.icon"
          :label="item.name"
          group="somegroup"
        >
          <q-list
            bordered
            separator
          >
            <div
              v-for="(itemChildren, indexChildren) in menu[index].children"
              v-bind:key="indexChildren"
            >
              <q-item
                clickable
                v-ripple
                :icon="itemChildren.icon"
                :label="itemChildren.label"
                :to="itemChildren.url"
                :active="active_link_menu === itemChildren.url"
                @click="active_link_menu = itemChildren.url"
                active-class="my-menu-link"
                v-if="can(itemChildren.permission)"
              >
                <q-item-section avatar>
                  <q-icon :name="itemChildren.icon" />
                </q-item-section>

                <q-item-section> {{itemChildren.name}} </q-item-section>
              </q-item>
            </div>
          </q-list>

        </q-expansion-item>
      </div>
    </q-drawer>

    <q-page-container>
      <router-view />
    </q-page-container>

  </q-layout>
</template>
<style>
.my-menu-link {
  color: white;
  background: #606063;
}
</style>
<script>
import { mapGetters, mapActions } from 'vuex'
export default {
  mounted () {
    this.verify()
    this.notify()
    this.$root.$on('notify', () => {
      this.notify()
    })
  },
  data () {
    return {
      list: [],
      left: false,
      nNotify: 0,
      myNotification: {},
      active_link_menu: '',
      menu: [
        {
          name: 'Admision',
          url: '',
          icon: 'settings',
          permission: 'alumns',
          children: [
            {
              name: 'Listado',
              permission: 'alumns.list',
              url: '/list',
              icon: 'supervisor_account'
            }
          ]
        },
        {
          name: 'Pagos',
          url: '',
          icon: 'table_chart',
          permission: 'counter',
          children: [
            {
              name: 'Registrar Costos',
              permission: 'counter',
              url: '/register_counter',
              icon: 'post_add'
            },
            {
              name: 'Pago Estudiantil',
              permission: 'attach_payment',
              url: '/attach_student',
              icon: 'attach_money'
            },
            {
              name: 'Deudores',
              permission: 'debts.list',
              url: '/debts_list',
              icon: 'money_off'
            }
          ]
        },
        {
          name: 'Información',
          url: '',
          icon: 'assignment',
          permission: 'admission',
          children: [
            {
              name: 'Agregar Documentos',
              permission: 'admission.documents',
              url: '/documents',
              icon: 'post_add'
            },
            {
              name: 'Completar Información',
              permission: 'admission.documents',
              url: '/information',
              icon: 'list'
            }
          ]
        },
        {
          name: 'Documentos',
          url: '',
          icon: 'assignment',
          permission: 'documents',
          children: [
            {
              name: 'Verificar Documentos',
              permission: 'documents.show',
              url: '/documents_show',
              icon: 'post_add'
            }
          ]
        },
        {
          name: 'Listado de Aspirantes',
          url: '',
          icon: 'assignment',
          permission: 'documents.show_cordination',
          children: [
            {
              name: 'Documentos',
              permission: 'documents.show_cordination',
              url: '/documents_show',
              icon: 'post_add'
            }
          ]
        },
        {
          name: 'Listado de Estudiantes',
          url: '',
          icon: 'assignment',
          permission: 'document.se',
          children: [
            {
              name: 'Verificar Documentos',
              permission: 'document.se',
              url: '/documents_show',
              icon: 'post_add'
            }
          ]
        },
        {
          name: 'Pruebas',
          url: '',
          icon: 'content_paste',
          permission: 'admission.test',
          children: [
            {
              name: 'Realizar Test',
              permission: 'admission.test',
              url: '/test',
              icon: 'short_text'
            }
          ]
        }
      ]
    }
  },
  computed: {
    ...mapGetters('generals', ['can', 'title', 'student'])
  },
  methods: {
    ...mapActions('generals', ['logout']),
    exit () {
      this.logout()
      this.$router.push('/')
    },
    verify () {
      console.log(this.title)
      const temp = localStorage.getItem('sessionInfo')
      if (temp === null) {
        this.$q.notify({
          position: 'bottom',
          textColor: 'white',
          icon: 'error',
          color: 'red',
          message: 'Intenta iniciar sesion primero'
        })
        this.logout()
        this.$router.push('/')
      } else if (temp !== null) {
        if (this.title === 'Estudiante') {
          console.log('Logueado un Estudiante')
          this.$router.push('/IndexStudent')
        } else {
          console.log('Logueado un administrador/Coordinador')
        }
      }
    },
    notify () {
      this.list = []
      this.$q.loading.show()
      this.$api.get('solicitudCount').then(res => {
        const dates = res
        this.nNotify = res.length
        for (const i in dates) {
          this.list.push({ name: dates[i].name, carrera: dates[i].carrera, dni: dates[i].dni, satus: dates[i].aprovated })
        }
        console.log(this.list)
        this.$q.loading.hide()
      })
    },
    ListNotify (dni) {
      this.$router.push(`/viewdates/${dni}`)
    }
  }
}
</script>
